#pragma once

#include "NPCommonUI.h"
#include <atlcoll.h>
#include "Object.h"

class PropertyBinder;

interface NPCOMMONUI_API IDataContext : public Object
{
public:
	enum {
		DEFAULT_KEY = 0,
	};
	IDataContext() {}
	virtual ~IDataContext(void) {}

	virtual CComVariant GetProperty(LPCTSTR propertyKey) = 0;
	virtual void SetProperty(LPCTSTR propertyKey, CComVariant propertyValue) = 0;
	virtual PropertyBinder* GetBinder() = 0;
	virtual void Sync() = 0;
	
	IDataContext* GetChildDataContext(IN OUT CString& propertyKey);
	static IDataContext* FindDataContext(LPCTSTR contextName);
	static CString GetToken(LPCTSTR key, int& start);
	
	//operation
	int GetCount(); 
	IDataContext* GetChild(int index);
	IDataContext* GetChild(LPCTSTR name);
	void Add(LPCTSTR name, IDataContext* child);
	void Remove(LPCTSTR name);
	void Remove(int indexRemove);
	void RemoveAll();
	CComVariant GetSystemProperty(LPCTSTR propertyKey);


public:
	CAtlMap<CString, CComVariant> m_mapData;

	
};
class NPCOMMONUI_API AbstractDataContext : public IDataContext
{
public:
	AbstractDataContext();
	~AbstractDataContext();

	//override
	PropertyBinder* GetBinder();
	void Sync();

	//operation
	void FirePropertyBindingListener(LPCTSTR propertyKey);

protected:
	PropertyBinder* m_PropertyBinder;
};
class NPCOMMONUI_API SimpleMapDataContext : public AbstractDataContext
{
public:
	SimpleMapDataContext() {}
	~SimpleMapDataContext() {}
	
	//override
	CComVariant GetProperty(LPCTSTR propertyKey);
	void SetProperty(LPCTSTR propertyKey, CComVariant propertyValue);
};